proc(x)=eye(d)
; -----------------------------------------------------------------
;   Library       multi
; -----------------------------------------------------------------
;   See_also      diag xdiag matrix unit zeros
; -----------------------------------------------------------------
;   Macro         eye
; -----------------------------------------------------------------
;   Description   creating a d-dimensional identity matrix
; -----------------------------------------------------------------
;   Usage         x = eye(d)
;   Input
;     Parameter   d
;     Definition      integer, dimension of matrix
;   Output
;     Parameter   x
;     Definition      d x d unit matrix
; -----------------------------------------------------------------
;   Example   library("multi")
;             eye(3)
; -----------------------------------------------------------------
;   Result    Contents of x
;       [1,]   1   0   0 
;       [2,]   0   1   0 
;       [3,]   0   0   1 
; -----------------------------------------------------------------
;   Author    Christopher Kath, Sperlich  971022
; -----------------------------------------------------------------
  x=diag(matrix(d))  
endp
