proc(noise)=noise(x)
; ---------------------------------------------------------------------
; Library     
; ---------------------------------------------------------------------
; See_also    cumsum
; ---------------------------------------------------------------------
; Macro       noise
; ---------------------------------------------------------------------
; Description Counterpart to cumsum, difference x(t)-x(t-1)
; ---------------------------------------------------------------------
; Usage       (noise)=noise(x)
; Input       
; Parameter   x input series (i.e Brownian Motion)
; Definition  
; Output      
; Parameter   noise series of noise
; Definition  
; ---------------------------------------------------------------------
; Notes       
; ---------------------------------------------------------------------
; Example     x=normal(4)
;							x=cumsum(x)
;							x=noise(x)
; ---------------------------------------------------------------------
; Result      Contents of x
;							[1,]  0.43221
;							[2,] -0.59753
;							[3,]  -1.2764
; ---------------------------------------------------------------------
; Keywords    Gaussian Noise
; ---------------------------------------------------------------------
; Reference   
; ---------------------------------------------------------------------
; Link        
; ---------------------------------------------------------------------
; Author      Arne Wuensche 000412
; ---------------------------------------------------------------------
//
n=rows(x)
i=0
y=matrix(n-1)
while (i<n-1)
	i=i+1
	y[i]=x[i+1]-x[i]
endo
noise=y
endp