/* cortb.f -- translated by f2c (version 19950110).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Subroutine */ int cortb_(nm, low, igh, ar, ai, ortr, orti, m, zr, zi)
integer *nm, *low, *igh;
doublereal *ar, *ai, *ortr, *orti;
integer *m;
doublereal *zr, *zi;
{
    /* System generated locals */
    integer ar_dim1, ar_offset, ai_dim1, ai_offset, zr_dim1, zr_offset, 
	    zi_dim1, zi_offset, i__1, i__2, i__3;

    /* Local variables */
    static doublereal h;
    static integer i, j, la;
    static doublereal gi, gr;
    static integer mm, mp, kp1, mp1;



/*     this subroutine is a translation of a complex analogue of */
/*     the algol procedure ortbak, num. math. 12, 349-368(1968) */
/*     by martin and wilkinson. */
/*     handbook for auto. comp., vol.ii-linear algebra, 339-358(1971). */

/*     this subroutine forms the eigenvectors of a complex general */
/*     matrix by back transforming those of the corresponding */
/*     upper hessenberg matrix determined by  corth. */

/*     on input */

/*        nm must be set to the row dimension of two-dimensional */
/*          array parameters as declared in the calling program */
/*          dimension statement. */

/*        low and igh are integers determined by the balancing */
/*          subroutine  cbal.  if  cbal  has not been used, */
/*          set low=1 and igh equal to the order of the matrix. */

/*        ar and ai contain information about the unitary */
/*          transformations used in the reduction by  corth */
/*          in their strict lower triangles. */

/*        ortr and orti contain further information about the */
/*          transformations used in the reduction by  corth. */
/*          only elements low through igh are used. */

/*        m is the number of columns of zr and zi to be back transformed. 
*/

/*        zr and zi contain the real and imaginary parts, */
/*          respectively, of the eigenvectors to be */
/*          back transformed in their first m columns. */

/*     on output */

/*        zr and zi contain the real and imaginary parts, */
/*          respectively, of the transformed eigenvectors */
/*          in their first m columns. */

/*        ortr and orti have been altered. */

/*     note that cortb preserves vector euclidean norms. */

/*     questions and comments should be directed to burton s. garbow, */
/*     mathematics and computer science div, argonne national laboratory 
*/

/*     this version dated august 1983. */

/*     ------------------------------------------------------------------ 
*/

    /* Parameter adjustments */
    --orti;
    --ortr;
    ai_dim1 = *nm;
    ai_offset = ai_dim1 + 1;
    ai -= ai_offset;
    ar_dim1 = *nm;
    ar_offset = ar_dim1 + 1;
    ar -= ar_offset;
    zi_dim1 = *nm;
    zi_offset = zi_dim1 + 1;
    zi -= zi_offset;
    zr_dim1 = *nm;
    zr_offset = zr_dim1 + 1;
    zr -= zr_offset;

    /* Function Body */
    if (*m == 0) {
	goto L200;
    }
    la = *igh - 1;
    kp1 = *low + 1;
    if (la < kp1) {
	goto L200;
    }
/*     .......... for mp=igh-1 step -1 until low+1 do -- .......... */
    i__1 = la;
    for (mm = kp1; mm <= i__1; ++mm) {
	mp = *low + *igh - mm;
	if (ar[mp + (mp - 1) * ar_dim1] == 0. && ai[mp + (mp - 1) * ai_dim1] 
		== 0.) {
	    goto L140;
	}
/*     .......... h below is negative of h formed in corth .......... 
*/
	h = ar[mp + (mp - 1) * ar_dim1] * ortr[mp] + ai[mp + (mp - 1) * 
		ai_dim1] * orti[mp];
	mp1 = mp + 1;

	i__2 = *igh;
	for (i = mp1; i <= i__2; ++i) {
	    ortr[i] = ar[i + (mp - 1) * ar_dim1];
	    orti[i] = ai[i + (mp - 1) * ai_dim1];
/* L100: */
	}

	i__2 = *m;
	for (j = 1; j <= i__2; ++j) {
	    gr = 0.;
	    gi = 0.;

	    i__3 = *igh;
	    for (i = mp; i <= i__3; ++i) {
		gr = gr + ortr[i] * zr[i + j * zr_dim1] + orti[i] * zi[i + j *
			 zi_dim1];
		gi = gi + ortr[i] * zi[i + j * zi_dim1] - orti[i] * zr[i + j *
			 zr_dim1];
/* L110: */
	    }

	    gr /= h;
	    gi /= h;

	    i__3 = *igh;
	    for (i = mp; i <= i__3; ++i) {
		zr[i + j * zr_dim1] = zr[i + j * zr_dim1] + gr * ortr[i] - gi 
			* orti[i];
		zi[i + j * zi_dim1] = zi[i + j * zi_dim1] + gr * orti[i] + gi 
			* ortr[i];
/* L120: */
	    }

/* L130: */
	}

L140:
	;
    }

L200:
    return 0;
} /* cortb_ */

