; ----------------------------------------------------------------------------
; Library       xag
; ----------------------------------------------------------------------------
; See_also      eivknownratue
; ----------------------------------------------------------------------------
; Macro         eiv02
; ----------------------------------------------------------------------------
; Description   estimates the parameters of eiv model for pheasant data 
;		with known ratio of the measurement errors
; ----------------------------------------------------------------------------
library("eiv")
v=read("pheasants.dat")
n=rows(v)
y=v[,2]
x=v[,3]
delta=1/6
gest=eivknownratue(x,y,delta)
data=sort(x~y)
data1=x~gest.beta0+gest.beta1*x
xx=matrix(rows(x))~x
vv=inv(xx'*xx)*(xx'*y)
data2=x~vv[1]+vv[2]*x
dds1=createdisplay(1,1)
part=grid(1,1,rows(x))'
color=0*matrix(rows(x))
color1=0*matrix(rows(x))
color2=4*matrix(rows(x))
layout=3*matrix(rows(x))
layout1=1*matrix(rows(x))
layout2=0*matrix(rows(x))
setmaskp(data,color,layout,9)
setmaskp(data1,color1,layout1,1)
setmaskp(data2,color2,layout2,1)
setmaskl(data,part,0,0,1)
setmaskl(data1,part,0,1,1)
setmaskl(data2,part,4,8,1)
show(dds1,1,1,data,data1,data2)
setgopt(dds1,1,1,"xlabel","Spring Hens","title","Pheasant data","ylabel","August hens")
; uncomment the following line for a PS picture
; print(dds1,"eivknownratuetu.ps")
