; ----------------------------------------------------------------------------
; Library       xag
; ----------------------------------------------------------------------------
; See_also      eivlinearinstr
; ----------------------------------------------------------------------------
; Macro         eiv05
; ----------------------------------------------------------------------------
; Description   estimates the parameters of eiv model for Alaskan earthquakes 
;               data with linear instrumental variable
; ----------------------------------------------------------------------------
library("eiv")
v=read("alaskan.dat")
n=rows(v)
y=v[,2]
x=v[,3]
w=v[,4]
gest=eivlinearinstr(x,w,y)
data=sort(x~y)
data1=x~gest.beta0+gest.beta1*x
xx=matrix(rows(x))~x
vv=inv(xx'*xx)*(xx'*y)
data2=x~vv[1]+vv[2]*x
dds=createdisplay(1,1)
part=grid(1,1,rows(x))'
color=0*matrix(rows(x))
color1=2*matrix(rows(x))
color2=5*matrix(rows(x))
layout=3*matrix(rows(x))
layout1=1*matrix(rows(x))
layout2=1*matrix(rows(x))
setmaskp(data,color,layout,9)
setmaskp(data1,color1,layout1,2)
setmaskp(data2,color2,layout2,3)
setmaskl(data,part,0,0,1)
setmaskl(data1,part,1,1,1)
setmaskl(data2,part,0,7,1)
show(dds,1,1,data,data1,data2)
setgopt(dds,1,1,"xlabel","Body wave","title","Alaskan earthquakes","ylabel","Surface wave")
; uncomment the following line for a PS picture
; print(dds,"eivlinearinstrtu.ps")
