; ----------------------------------------------------------------------------
; Library       xag
; ----------------------------------------------------------------------------
; See_also      read summarize
; ----------------------------------------------------------------------------
; Macro         gplm01
; ----------------------------------------------------------------------------
; Description   Summary statistics for the Credit data.
; ----------------------------------------------------------------------------
  library("stats")
;
  file=read("kredit")  
  file=paf(file,(file[,5]>=1)&&(file[,5]<=3)) 
                                     ; purpose=car/furniture
  y=file[,1]
  x=(file[,4]>2)                     ; previous loans o.k.
  x=x~(file[,8]>2)                   ; employed (>=1 year)
  x=x~(file[,3])                     ; duration of loan
  t=(file[,6])                       ; amount of loan
  t=t~(file[,14])                    ; age of client
  xvars="previous"|"employed"|"duration"
  tvars="amount"|"age"
;
  summarize(y~x~t,"y"|xvars|tvars)

