; -----------------------------------------------------------------
; Library        METRIC
; -----------------------------------------------------------------
;   Macro        metric03
; -----------------------------------------------------------------
;   Description  Illustrates density weighted average derivative 
;                estimation.
; -----------------------------------------------------------------
library("metrics")
randomize(333)
n     = 500
x     = normal(n,3)
beta  =#(0.2 , -0.7 , 1)
index = x*beta
eps   = normal(n,1) * sqrt(0.5)
y     = 2 * index^3 + eps
h     = 0.3
d     = dwade(x,y,h)
(d/d[1])~(beta/beta[1])
