/* figi.f -- translated by f2c (version 19950110).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Subroutine */ int figi_(nm, n, t, d, e, e2, ierr)
integer *nm, *n;
doublereal *t, *d, *e, *e2;
integer *ierr;
{
    /* System generated locals */
    integer t_dim1, t_offset, i__1;
    doublereal d__1;

    /* Builtin functions */
    double sqrt();

    /* Local variables */
    static integer i;



/*     given a nonsymmetric tridiagonal matrix such that the products */
/*     of corresponding pairs of off-diagonal elements are all */
/*     non-negative, this subroutine reduces it to a symmetric */
/*     tridiagonal matrix with the same eigenvalues.  if, further, */
/*     a zero product only occurs when both factors are zero, */
/*     the reduced matrix is similar to the original matrix. */

/*     on input */

/*        nm must be set to the row dimension of two-dimensional */
/*          array parameters as declared in the calling program */
/*          dimension statement. */

/*        n is the order of the matrix. */

/*        t contains the input matrix.  its subdiagonal is */
/*          stored in the last n-1 positions of the first column, */
/*          its diagonal in the n positions of the second column, */
/*          and its superdiagonal in the first n-1 positions of */
/*          the third column.  t(1,1) and t(n,3) are arbitrary. */

/*     on output */

/*        t is unaltered. */

/*        d contains the diagonal elements of the symmetric matrix. */

/*        e contains the subdiagonal elements of the symmetric */
/*          matrix in its last n-1 positions.  e(1) is not set. */

/*        e2 contains the squares of the corresponding elements of e. */
/*          e2 may coincide with e if the squares are not needed. */

/*        ierr is set to */
/*          zero       for normal return, */
/*          n+i        if t(i,1)*t(i-1,3) is negative, */
/*          -(3*n+i)   if t(i,1)*t(i-1,3) is zero with one factor */
/*                     non-zero.  in this case, the eigenvectors of */
/*                     the symmetric matrix are not simply related */
/*                     to those of  t  and should not be sought. */

/*     questions and comments should be directed to burton s. garbow, */
/*     mathematics and computer science div, argonne national laboratory 
*/

/*     this version dated august 1983. */

/*     ------------------------------------------------------------------ 
*/

    /* Parameter adjustments */
    t_dim1 = *nm;
    t_offset = t_dim1 + 1;
    t -= t_offset;
    --e2;
    --e;
    --d;

    /* Function Body */
    *ierr = 0;

    i__1 = *n;
    for (i = 1; i <= i__1; ++i) {
	if (i == 1) {
	    goto L90;
	}
	e2[i] = t[i + t_dim1] * t[i - 1 + t_dim1 * 3];
	if ((d__1 = e2[i]) < 0.) {
	    goto L1000;
	} else if (d__1 == 0) {
	    goto L60;
	} else {
	    goto L80;
	}
L60:
	if (t[i + t_dim1] == 0. && t[i - 1 + t_dim1 * 3] == 0.) {
	    goto L80;
	}
/*     .......... set error -- product of some pair of off-diagonal */
/*                elements is zero with one member non-zero ..........
 */
	*ierr = -(*n * 3 + i);
L80:
	e[i] = sqrt(e2[i]);
L90:
	d[i] = t[i + (t_dim1 << 1)];
/* L100: */
    }

    goto L1001;
/*     .......... set error -- product of some pair of off-diagonal */
/*                elements is negative .......... */
L1000:
    *ierr = *n + i;
L1001:
    return 0;
} /* figi_ */

