/* figi2.f -- translated by f2c (version 19950110).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Subroutine */ int figi2_(nm, n, t, d, e, z, ierr)
integer *nm, *n;
doublereal *t, *d, *e, *z;
integer *ierr;
{
    /* System generated locals */
    integer t_dim1, t_offset, z_dim1, z_offset, i__1, i__2;

    /* Builtin functions */
    double sqrt();

    /* Local variables */
    static doublereal h;
    static integer i, j;



/*     given a nonsymmetric tridiagonal matrix such that the products */
/*     of corresponding pairs of off-diagonal elements are all */
/*     non-negative, and zero only when both factors are zero, this */
/*     subroutine reduces it to a symmetric tridiagonal matrix */
/*     using and accumulating diagonal similarity transformations. */

/*     on input */

/*        nm must be set to the row dimension of two-dimensional */
/*          array parameters as declared in the calling program */
/*          dimension statement. */

/*        n is the order of the matrix. */

/*        t contains the input matrix.  its subdiagonal is */
/*          stored in the last n-1 positions of the first column, */
/*          its diagonal in the n positions of the second column, */
/*          and its superdiagonal in the first n-1 positions of */
/*          the third column.  t(1,1) and t(n,3) are arbitrary. */

/*     on output */

/*        t is unaltered. */

/*        d contains the diagonal elements of the symmetric matrix. */

/*        e contains the subdiagonal elements of the symmetric */
/*          matrix in its last n-1 positions.  e(1) is not set. */

/*        z contains the transformation matrix produced in */
/*          the reduction. */

/*        ierr is set to */
/*          zero       for normal return, */
/*          n+i        if t(i,1)*t(i-1,3) is negative, */
/*          2*n+i      if t(i,1)*t(i-1,3) is zero with */
/*                     one factor non-zero. */

/*     questions and comments should be directed to burton s. garbow, */
/*     mathematics and computer science div, argonne national laboratory 
*/

/*     this version dated august 1983. */

/*     ------------------------------------------------------------------ 
*/

    /* Parameter adjustments */
    t_dim1 = *nm;
    t_offset = t_dim1 + 1;
    t -= t_offset;
    z_dim1 = *nm;
    z_offset = z_dim1 + 1;
    z -= z_offset;
    --e;
    --d;

    /* Function Body */
    *ierr = 0;

    i__1 = *n;
    for (i = 1; i <= i__1; ++i) {

	i__2 = *n;
	for (j = 1; j <= i__2; ++j) {
/* L50: */
	    z[i + j * z_dim1] = 0.;
	}

	if (i == 1) {
	    goto L70;
	}
	h = t[i + t_dim1] * t[i - 1 + t_dim1 * 3];
	if (h < 0.) {
	    goto L900;
	} else if (h == 0) {
	    goto L60;
	} else {
	    goto L80;
	}
L60:
	if (t[i + t_dim1] != 0. || t[i - 1 + t_dim1 * 3] != 0.) {
	    goto L1000;
	}
	e[i] = 0.;
L70:
	z[i + i * z_dim1] = 1.;
	goto L90;
L80:
	e[i] = sqrt(h);
	z[i + i * z_dim1] = z[i - 1 + (i - 1) * z_dim1] * e[i] / t[i - 1 + 
		t_dim1 * 3];
L90:
	d[i] = t[i + (t_dim1 << 1)];
/* L100: */
    }

    goto L1001;
/*     .......... set error -- product of some pair of off-diagonal */
/*                elements is negative .......... */
L900:
    *ierr = *n + i;
    goto L1001;
/*     .......... set error -- product of some pair of off-diagonal */
/*                elements is zero with one member non-zero .......... */
L1000:
    *ierr = (*n << 1) + i;
L1001:
    return 0;
} /* figi2_ */

