/* htrid3.f -- translated by f2c (version 19950110).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Subroutine */ int htrid3_(nm, n, a, d, e, e2, tau)
integer *nm, *n;
doublereal *a, *d, *e, *e2, *tau;
{
    /* System generated locals */
    integer a_dim1, a_offset, i__1, i__2, i__3;
    doublereal d__1, d__2;

    /* Builtin functions */
    double sqrt();

    /* Local variables */
    static doublereal f, g, h;
    static integer i, j, k, l;
    static doublereal scale, fi, gi, hh;
    static integer ii;
    static doublereal si;
    extern doublereal pythag_();
    static integer jm1, jp1;



/*     this subroutine is a translation of a complex analogue of */
/*     the algol procedure tred3, num. math. 11, 181-195(1968) */
/*     by martin, reinsch, and wilkinson. */
/*     handbook for auto. comp., vol.ii-linear algebra, 212-226(1971). */

/*     this subroutine reduces a complex hermitian matrix, stored as */
/*     a single square array, to a real symmetric tridiagonal matrix */
/*     using unitary similarity transformations. */

/*     on input */

/*        nm must be set to the row dimension of two-dimensional */
/*          array parameters as declared in the calling program */
/*          dimension statement. */

/*        n is the order of the matrix. */

/*        a contains the lower triangle of the complex hermitian input */
/*          matrix.  the real parts of the matrix elements are stored */
/*          in the full lower triangle of a, and the imaginary parts */
/*          are stored in the transposed positions of the strict upper */
/*          triangle of a.  no storage is required for the zero */
/*          imaginary parts of the diagonal elements. */

/*     on output */

/*        a contains information about the unitary transformations */
/*          used in the reduction. */

/*        d contains the diagonal elements of the the tridiagonal matrix. 
*/

/*        e contains the subdiagonal elements of the tridiagonal */
/*          matrix in its last n-1 positions.  e(1) is set to zero. */

/*        e2 contains the squares of the corresponding elements of e. */
/*          e2 may coincide with e if the squares are not needed. */

/*        tau contains further information about the transformations. */

/*     calls pythag for  dsqrt(a*a + b*b) . */

/*     questions and comments should be directed to burton s. garbow, */
/*     mathematics and computer science div, argonne national laboratory 
*/

/*     this version dated august 1983. */

/*     ------------------------------------------------------------------ 
*/

    /* Parameter adjustments */
    tau -= 3;
    --e2;
    --e;
    --d;
    a_dim1 = *nm;
    a_offset = a_dim1 + 1;
    a -= a_offset;

    /* Function Body */
    tau[(*n << 1) + 1] = 1.;
    tau[(*n << 1) + 2] = 0.;
/*     .......... for i=n step -1 until 1 do -- .......... */
    i__1 = *n;
    for (ii = 1; ii <= i__1; ++ii) {
	i = *n + 1 - ii;
	l = i - 1;
	h = 0.;
	scale = 0.;
	if (l < 1) {
	    goto L130;
	}
/*     .......... scale row (algol tol then not needed) .......... */
	i__2 = l;
	for (k = 1; k <= i__2; ++k) {
/* L120: */
	    scale = scale + (d__1 = a[i + k * a_dim1], abs(d__1)) + (d__2 = a[
		    k + i * a_dim1], abs(d__2));
	}

	if (scale != 0.) {
	    goto L140;
	}
	tau[(l << 1) + 1] = 1.;
	tau[(l << 1) + 2] = 0.;
L130:
	e[i] = 0.;
	e2[i] = 0.;
	goto L290;

L140:
	i__2 = l;
	for (k = 1; k <= i__2; ++k) {
	    a[i + k * a_dim1] /= scale;
	    a[k + i * a_dim1] /= scale;
	    h = h + a[i + k * a_dim1] * a[i + k * a_dim1] + a[k + i * a_dim1] 
		    * a[k + i * a_dim1];
/* L150: */
	}

	e2[i] = scale * scale * h;
	g = sqrt(h);
	e[i] = scale * g;
	f = pythag_(&a[i + l * a_dim1], &a[l + i * a_dim1]);
/*     .......... form next diagonal element of matrix t .......... */
	if (f == 0.) {
	    goto L160;
	}
	tau[(l << 1) + 1] = (a[l + i * a_dim1] * tau[(i << 1) + 2] - a[i + l *
		 a_dim1] * tau[(i << 1) + 1]) / f;
	si = (a[i + l * a_dim1] * tau[(i << 1) + 2] + a[l + i * a_dim1] * tau[
		(i << 1) + 1]) / f;
	h += f * g;
	g = g / f + 1.;
	a[i + l * a_dim1] = g * a[i + l * a_dim1];
	a[l + i * a_dim1] = g * a[l + i * a_dim1];
	if (l == 1) {
	    goto L270;
	}
	goto L170;
L160:
	tau[(l << 1) + 1] = -tau[(i << 1) + 1];
	si = tau[(i << 1) + 2];
	a[i + l * a_dim1] = g;
L170:
	f = 0.;

	i__2 = l;
	for (j = 1; j <= i__2; ++j) {
	    g = 0.;
	    gi = 0.;
	    if (j == 1) {
		goto L190;
	    }
	    jm1 = j - 1;
/*     .......... form element of a*u .......... */
	    i__3 = jm1;
	    for (k = 1; k <= i__3; ++k) {
		g = g + a[j + k * a_dim1] * a[i + k * a_dim1] + a[k + j * 
			a_dim1] * a[k + i * a_dim1];
		gi = gi - a[j + k * a_dim1] * a[k + i * a_dim1] + a[k + j * 
			a_dim1] * a[i + k * a_dim1];
/* L180: */
	    }

L190:
	    g += a[j + j * a_dim1] * a[i + j * a_dim1];
	    gi -= a[j + j * a_dim1] * a[j + i * a_dim1];
	    jp1 = j + 1;
	    if (l < jp1) {
		goto L220;
	    }

	    i__3 = l;
	    for (k = jp1; k <= i__3; ++k) {
		g = g + a[k + j * a_dim1] * a[i + k * a_dim1] - a[j + k * 
			a_dim1] * a[k + i * a_dim1];
		gi = gi - a[k + j * a_dim1] * a[k + i * a_dim1] - a[j + k * 
			a_dim1] * a[i + k * a_dim1];
/* L200: */
	    }
/*     .......... form element of p .......... */
L220:
	    e[j] = g / h;
	    tau[(j << 1) + 2] = gi / h;
	    f = f + e[j] * a[i + j * a_dim1] - tau[(j << 1) + 2] * a[j + i * 
		    a_dim1];
/* L240: */
	}

	hh = f / (h + h);
/*     .......... form reduced a .......... */
	i__2 = l;
	for (j = 1; j <= i__2; ++j) {
	    f = a[i + j * a_dim1];
	    g = e[j] - hh * f;
	    e[j] = g;
	    fi = -a[j + i * a_dim1];
	    gi = tau[(j << 1) + 2] - hh * fi;
	    tau[(j << 1) + 2] = -gi;
	    a[j + j * a_dim1] -= (f * g + fi * gi) * 2.;
	    if (j == 1) {
		goto L260;
	    }
	    jm1 = j - 1;

	    i__3 = jm1;
	    for (k = 1; k <= i__3; ++k) {
		a[j + k * a_dim1] = a[j + k * a_dim1] - f * e[k] - g * a[i + 
			k * a_dim1] + fi * tau[(k << 1) + 2] + gi * a[k + i * 
			a_dim1];
		a[k + j * a_dim1] = a[k + j * a_dim1] - f * tau[(k << 1) + 2] 
			- g * a[k + i * a_dim1] - fi * e[k] - gi * a[i + k * 
			a_dim1];
/* L250: */
	    }

L260:
	    ;
	}

L270:
	i__2 = l;
	for (k = 1; k <= i__2; ++k) {
	    a[i + k * a_dim1] = scale * a[i + k * a_dim1];
	    a[k + i * a_dim1] = scale * a[k + i * a_dim1];
/* L280: */
	}

	tau[(l << 1) + 2] = -si;
L290:
	d[i] = a[i + i * a_dim1];
	a[i + i * a_dim1] = scale * sqrt(h);
/* L300: */
    }

    return 0;
} /* htrid3_ */

