proc(y)=diagrv(x,v)
; -----------------------------------------------------------------
;   Library       multi
; -----------------------------------------------------------------
;   See_also      diag
; -----------------------------------------------------------------
;   Macro         diagrv
; -----------------------------------------------------------------
;   Description   replaces the diagonal of x by v
; -----------------------------------------------------------------
;   Usage         y = diagrv(x,v)
;   Input
;     Parameter   x
;     Definition      N x K matrix 
;     Parameter   v
;     Definition      nk x 1 vector, where nk is min(N,K)  
;   Output
;     Parameter   y
;     Definition      N x K matrix
; -----------------------------------------------------------------
;   Example   library("multi")
;             diagrv(eye(2),5|5)
; -----------------------------------------------------------------
;   Result   Contents of y 
;       [1,]   5   0    
;       [2,]   0   5    
; -----------------------------------------------------------------
;   Author    Christian Hafner, Sperlich  971023
; -----------------------------------------------------------------
y=x
i=1
while(i<=min(rows(x)|cols(x)))
  y[i,i]=v[i]
  i=i+1
endo
endp
