proc()=european()
; -----------------------------------------------------------------
; Library  	  finance
; -----------------------------------------------------------------
;  See_also       american, bs1, volatility
; -----------------------------------------------------------------
;   Macro         european
; -----------------------------------------------------------------
;   Description   starting program to calculate option prices 
;                 or implied volatilities for european options
; -----------------------------------------------------------------
;   Usage         european()
;   Input         
;   Output        
; -----------------------------------------------------------------
;   Example   library("finance")
;             european()
; -----------------------------------------------------------------
;   Result    option price or implied volatility of european options 
;             using the Black and Scholes formula 
; -----------------------------------------------------------------
;   Author    Feldmann, Sperlich  970217 
; -----------------------------------------------------------------
job=0
do
  selhead = "Choose the underlying asset for your option."
  selitem = "Stock"|"Exchange Rate" 
       sel1 = selectitem (selhead, selitem)
       if (sel1[1]) 
     	   selhead = "Do you want dividends to be included?"
           selitem = "No"|"Continually paid"|"Fixed, paid at time T" 
             sel2 = selectitem (selhead, selitem)
             if (sel2[1])
		job = 1 
             endif 
             if (sel2[2])
		job = 2
             endif
             if (sel2[3])
		job = 3
             endif
      endif 
      if (sel1[2])
        job = 4
      endif 
until(job)
  selhead = "What do You want to compute?"
  selitem = "Option Price"|"Implied Volatility" 
  sel3 = selectitem (selhead, selitem)
     if (sel3[1])
        bs1(job)
     endif 
     if (sel3[2])
        volatility(job)
     endif 
endp
