proc (y)=gau(x)

; -----------------------------------------------------------------
; Library       kernel
; -----------------------------------------------------------------
;  See_also     cosi epa qua tri trian uni
; -----------------------------------------------------------------
;   Macro       gau
; -----------------------------------------------------------------
;   Description  gau computes the gaussian kernel, multivariate
; -----------------------------------------------------------------
;   Usage        y = gau(x)
;   Input
;     Parameter  x  
;     Definition  n x p matrix
;   Output
;     Parameter  y  
;     Definition  n x 1 matrix
; -----------------------------------------------------------------
;   Example   library("kernel") 
;             x = aseq(-1, 21, 0.1) 
;             y = gau(x) 
;             t=createdisplay(1,1)                                      
;             show(t,1,1,x~y)                                    
; -----------------------------------------------------------------
;   Result    The kernel is pictured  
; -----------------------------------------------------------------
;   Author    Wolfgang Haerdle, Sigbert Klinke, Lijian Yang, 951117   
; -----------------------------------------------------------------


  y=prod(pdfn(x),2)

endp
