proc()=plotbar(x)
; -----------------------------------------------------------------------
; Library      plot
; -----------------------------------------------------------------------
; See_also     grbar dispbar
; -----------------------------------------------------------------------
; Macro        plotbar
; -----------------------------------------------------------------------
; Description  plots each variable in a separate barchart 
; -----------------------------------------------------------------------
; Usage        plotbar(x)
; Input        
;   Parameter  x
;   Definition n x p number or text matrix
; -----------------------------------------------------------------------
; Example      library ("plot")
;              t  = floor((normal(25)-8)|(normal(25)+8)|normal(100)|(normal(10)+25))
;              plotbar (t)
; -----------------------------------------------------------------------
; Result       plots a barchart of t
; -----------------------------------------------------------------------
; Link         ../tutorials/graphicstart.html  Introduction to the graphic library
; -----------------------------------------------------------------------
; Keywords     graphic primitives, bar chart
; -----------------------------------------------------------------------
; Author       Sigbert Klinke, 960925,980805
; -----------------------------------------------------------------------
  dispplotbar = createdisplay(cols(x),1)
  i = 0
  while (i<cols(x))
    i = i+1
    dispbar(dispplotbar,i,1,x[,i])
  endo
endp