proc(y)=power(matrixx,exponent)
; -----------------------------------------------------------------
;   Library       multi
; -----------------------------------------------------------------
;   See_also      ^
; -----------------------------------------------------------------
;   Macro         power
; -----------------------------------------------------------------
;   Description   calculates x to the power of exponent
; -----------------------------------------------------------------
;   Usage         y =power(matrixx,exponent)
;   Input
;     Parameter   matrixx 
;     Definition    n x n matrix 
;     Parameter   exponent
;     Definition    integer, exponent of the matrix
;   Output
;     Parameter   y
;     Definition    matrix, x^exponent
; -----------------------------------------------------------------
;   Example   library("multi")
;             randomize(1000)
;             x = normal(3,3)
;             y = power(x,2)
;             y
; -----------------------------------------------------------------
;   Result    Contents of y
;             [1,]   3.6194   1.9439 -0.96658 
;             [2,]  -4.5294     1.85   1.3923 
;             [3,]  -3.1163 -0.13572    9.987 
; -----------------------------------------------------------------
;   Author    Hafner, Sperlich  971027
; -----------------------------------------------------------------
r=rows(matrixx)
if (exponent .<0)
   y=matrix(r,r)*0
else
  y=eye(r)
  j=1
  while (j<=exponent)
     y=y*matrixx
     j=j+1
  endo
endif
endp
