proc (xv, wout, s) = runnet(disp, w, u, m, x, y, t, dec, opt, err, res, fs, weidist, vmeth)               
; -----------------------------------------------------------------------
; Library      nn
; -----------------------------------------------------------------------
; See_also     ann
; -----------------------------------------------------------------------
; Macro        runnet
; -----------------------------------------------------------------------
; Description  runs a network with prespecified optimization method
; -----------------------------------------------------------------------
; Author       Sigbert Klinke, Janet Grassmann,  951231; Sigbert Klinke, 961121
; -----------------------------------------------------------------------
  wout = w
  switch 
  case (err.=0)            
    errfun = "erfqua" 
    break           
  case (err.=1)               
    errfun = "erfkl"
    break               
  endsw             
  if (cols(wout).>3)             
    str = string ("Net (0-%.f):", cols(wout)-3)               
    j   = readvalue (str, 0)               
    wout   = wout[,1:2]~wout[,3+j]               
  endif               
  switch 
  case (opt.=0)               
    {xv, wout, s}=runqsa(disp, wout, u, m, x, y, t, errfun, dec, res, fs, weidist, vmeth) 
    break              
  case (opt.=1)               
    {xv, wout, s}=runsa(disp, wout, u, m, x, y, t, errfun, dec, res, fs, weidist, vmeth)
    break               
  case (opt.=2)               
    {xv, wout, s}=runnew(disp, wout, u, m, x, y, t, errfun, dec, res, fs, weidist, vmeth)
    break     
  endsw
endp               
