proc (v, wo, s) = runqsa(disp, w, u, m, x, y, t, errfun, dec, res, fs, weidist, vmeth)
; -----------------------------------------------------------------------
; Library      nn
; -----------------------------------------------------------------------
; See_also     ann
; -----------------------------------------------------------------------
; Macro        runqsa
; -----------------------------------------------------------------------
; Description  optimizes a neural network by a stochastic search
; -----------------------------------------------------------------------
; Author      Sigbert Klinke, Janet Grassmann,  951231; Sigbert Klinke, 961121
; -----------------------------------------------------------------------
  wo = w
  {xt, yt, xe, ye, we, s, yep, ybp, v, ve} = runinit(x, y, t, errfun, w, u, dec, m, vmeth)
  i = 1               
  dt = 0.99
; dt = 0.1      
  while (res)               
    t  = 1               
    ;while ((t.>0.01) && (readcon(0).=0))       
    while (t.>0.01)   
      wb = wo[,1:2]~(wo[,3]+t.*normal(rows(wo))) 
      yb = nnfunc(wb, u, xt)
      s[1,1] = _errfun(yt, yb, wb[,3], dec)               
      if (s[1,1].<s[1,2])               
        {wo, s, v, we, ybp, yep, ve}=runshow(disp, wb, u, s, m, v, ybp, yep, xt, xe, we, dec, ve, i, ye, res, weidist, errfun, vmeth)         
        t~s[1,1]~s[2,1]
        wb~we[,3]
        t = t./(dt^3)
      endif               
      i = i+1               
      t = t.*dt       
    endo            
    res = res-1               
  endo               
  wo = wb~we[,3]               
  s = s[,2]             
  if (fs)               
    finalshow (disp, wo, u, s, ybp, yep, xt, xe, dec, v, ve, m, weidist, vmeth)               
  endif               
endp               
