proc(s2)=sigma1(phi, sigma, h)
; ----------------------------------------------------------------------
; Library 	  multi
; ----------------------------------------------------------------------
;  See_also	  domulti
; ----------------------------------------------------------------------
;   Macro	  sigma1
; ----------------------------------------------------------------------
;   Description   auxiliary quantlet for full VAR model analysis 
; ----------------------------------------------------------------------
;   Usage         s2 = sigma1(phi, sigma, h)
;   Input 
;     Parameter   phi 
;     Definition     matrix 
;     Parameter   sigma 
;     Definition     vector, standard error
;     Parameter   h 
;     Definition     integer, forecast horizon
;   Output
;     Parameter   s2
;     Definition     matrix
; ----------------------------------------------------------------------
;   Author        Hafner, Sperlich 971212
; ---------------------------------------------------------------------- 
k=cols(phi)
s1=phi[1:k,]*sigma*phi[1:k,]'
s2=s1
i=2
while (i<=h);
   s1=s1+phi[k*(i-1)+1:k*i,]*sigma*phi[k*(i-1)+1:k*i,]'
   s2=s2|s1
   i=i+1
endo
endp

